const marked = require('marked')
const Base = marked.Renderer
const renderer = new marked.Renderer()

function insert(markup) {
  var prefix = markup.map(mark => `</${mark}>`).reverse().join('\n')
  var suffix = markup.map(mark => `<${mark}>`).join('\n')
  return prefix + suffix
}

renderer.paragraph = function(text) {
  var html = Base.prototype.paragraph.apply(this, arguments)
  return `<mj-text>${html}</mj-text>`
}

renderer.heading = function(text, level, raw) {
  var html = Base.prototype.heading.apply(this, arguments)
  return `<mj-text>${html}</mj-text>`
}

renderer.image = function(href, title, text) { 
  return `<mj-image src="${href}" title="${title}" alt="${text}" />`;
}

renderer.hr = function() {
  return insert(['mj-section', 'mj-column'])
}

marked.setOptions({
  renderer
})

module.exports = marked